/**
Action Script library.	Camera class implementation
Copyright (C) 2005  

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**/
#include "as_camera.hh"

typedef void (ASCamera::*funcPtr)();
static funcPtr callbacks[]= { 
	&ASCamera::init,			// 0
	&ASCamera::get,				// 1
	&ASCamera::setMode,			// 2
	&ASCamera::setMotionLevel,	// 3
	&ASCamera::setQuality,		// 4
	// Need to be at the end.
	&ASCamera::addProperty,		
	&ASCamera::registerClass,	
	&ASCamera::AStoString,		
	&ASCamera::unwatch,			
	&ASCamera::valueOf,			
	&ASCamera::watch			
};

/**
 * The constructor
 **/
ASCamera::ASCamera(Script *s, Graphics *g) : ASObject(s,g,L"Camera") {
}

/**
 * The destructor
 **/
ASCamera::~ASCamera() {
}

/**
 * Return a function descriptor
 */
Function *ASCamera::getFunctionMember(wstring memberName) {
	Function *func = getBaseFunction(memberName);
	if (memberName == L"Camera") 		{func->setFunctionIndex(0); func->setNumParams(0); }
	if (memberName == L"get") 			{func->setFunctionIndex(1); func->setNumParams(1); }
	if (memberName == L"setMode") 		{func->setFunctionIndex(2); func->setNumParams(4); }
	if (memberName == L"setMotionLevel"){func->setFunctionIndex(3); func->setNumParams(2); }
	if (memberName == L"setQuality") 	{func->setFunctionIndex(4); func->setNumParams(2); }
	finishFunctionSetup(memberName,5,func);
	return func;
}

/**
 * Call class built in functions
 **/
void ASCamera::callFunction(Function *func) {
	numPassedParams = func->getNumPassedParams();
	(this->*callbacks[func->getFunctionIndex()])();
}
/**
 *
 **/
void ASCamera::init() {
	puts("TODO");
}

/**
 * Returns a default or specified Camera object, or null if the camera is not available.
 **/
void ASCamera::get() {
	puts("TODO");
	noReturnValue();
}

/**
 * Sets aspects of the camera capture mode, including height, width, and frames per second.
 **/
void ASCamera::setMode() {
	puts("TODO");
	noReturnValue();
}

/**
 * Specifies how much motion is required to invoke Camera.onActivity(true) and how much time should elapse without motion before 
 * Camera.onActivity(false) is invoked.
 **/
void ASCamera::setMotionLevel() {
	puts("TODO");
	noReturnValue();
}

/**
 * An integer that specifies the maximum amount of bandwidth that the current outgoing video feed can use, in bytes per second.
 **/
void ASCamera::setQuality() {
	puts("TODO");
	noReturnValue();
}


