/**
Action Script library. Function class imlplementation
Copyright (C) 2005

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**/
#include "as_function.hh"

typedef void (ASFunction::*funcPtr)();
static funcPtr callbacks[]= { 
	&ASFunction::init,		// 0
	&ASFunction::apply,		// 1
	&ASFunction::call,		// 2
	// Need to be at the end.
	&ASFunction::addProperty,		
	&ASFunction::registerClass,	
	&ASFunction::AStoString,		
	&ASFunction::unwatch,			
	&ASFunction::valueOf,			
	&ASFunction::watch			
};

/**
 * The constructor
 **/
ASFunction::ASFunction(Script *s, Graphics *g) : ASObject(s,g,L"Function") {
}

/**
 * The destructor
 **/
ASFunction::~ASFunction() {
}

/**
 * Return a function descriptor
 */
Function *ASFunction::getFunctionMember(wstring memberName) {
	Function *func = getBaseFunction(memberName);
	if (memberName == L"Function") 	{func->setFunctionIndex(0); func->setNumParams(0); }
	if (memberName == L"apply") 	{func->setFunctionIndex(1); func->setNumParams(2); }
	if (memberName == L"call") 		{func->setFunctionIndex(2); func->setNumParams(10); } // inifinate
	finishFunctionSetup(memberName,3,func);
	return func;
}

/**
 * Call class built in functions
 **/
void ASFunction::callFunction(Function *func) {
	numPassedParams = func->getNumPassedParams();
	(this->*callbacks[func->getFunctionIndex()])();
}

/**
 *
 **/
void ASFunction::init() {
	puts("TODO");
}

/**
 * Enables ActionScript code to call a function.
 **/
void ASFunction::apply() {
	puts("TODO");
	noReturnValue();
}

/**
 * Invokes the function represented by a Function object.
 **/
void ASFunction::call() {
	puts("TODO");
	noReturnValue();
}
