/**
Action Script library. linker class (non Action script specified - used for built-in class linkage)
Copyright (C) 2005  Christophe Choquet (cchoquet@users.sourceforge.net) 

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**/
#ifndef _AS_LINKER_HH
#define _AS_LINKER_HH
#include "as_interface.hh"
typedef stdext::hash_map<wstring, wstring, HashUTF8String,  HashUTF8StringCompare> StringStringHashMap;

class ASLinker {
public:
	ASLinker(Script *s, Graphics *g); 
	~ASLinker();
	Function * getFunctionMember(wstring className, wstring methodName, ScriptObject **sc);
	Function * getCallFunction(wstring functionName,ScriptObject **sc);
	void callFunction(ScriptObject *sc, Function *f);
	ASInterface*getANewClassInstance(Script *s, Graphics *g,wstring classname);
	ScriptObject *getClassInstance(wstring className);
	ScriptObject *getClassSingleton(wstring className);
private:
	StringASHashMap	classes;
	StringStringHashMap callFunctions;
	Script 			*script;
	Graphics		*graphics;
};
#endif
