/**
Action Script library. Mouse class implementation
Copyright (C) 2005

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**/
#include "as_mouse.hh"

typedef void (ASMouse::*funcPtr)();
static funcPtr callbacks[]= { 
	&ASMouse::init,			// 0
	&ASMouse::addListener,	// 1
	&ASMouse::hide,			// 2
	&ASMouse::removeListener,// 3
	&ASMouse::show,			// 4
	// Need to be at the end.
	&ASMouse::addProperty,		
	&ASMouse::registerClass,	
	&ASMouse::AStoString,		
	&ASMouse::unwatch,			
	&ASMouse::valueOf,			
	&ASMouse::watch
};

/**
 * The constructor
 **/
ASMouse::ASMouse(Script *s, Graphics *g) : ASObject(s,g,L"Mouse") {
}

/**
 * The destructor
 **/
ASMouse::~ASMouse() {
}

/**
 * Return a function descriptor
 */
Function *ASMouse::getFunctionMember(wstring memberName) {
	Function *func = getBaseFunction(memberName);
	if (memberName == L"Mouse") 		{func->setFunctionIndex(0); func->setNumParams(0); } 
	if (memberName == L"addListener") 	{func->setFunctionIndex(1); func->setNumParams(1); } 
	if (memberName == L"hide") 			{func->setFunctionIndex(2); func->setNumParams(0); } 
	if (memberName == L"removeListener"){func->setFunctionIndex(3); func->setNumParams(1); }
	if (memberName == L"show") 			{func->setFunctionIndex(4); func->setNumParams(0); }
	finishFunctionSetup(memberName,5,func);
	return func;
}

/**
 * Call class built in functions
 **/
void ASMouse::callFunction(Function *func) {
	numPassedParams = func->getNumPassedParams();
	(this->*callbacks[func->getFunctionIndex()])();
}

/**
 *
 **/
void ASMouse::init() {
	puts("TODO");
}

/**
 * Registers an object to receive onMouseDown, onMouseMove, and onMouseUp notification.
 **/
void ASMouse::addListener() {
	puts("TODO");
	noReturnValue();
}

/**
 * Hides the mouse pointer in the SWF file.
 **/
void ASMouse::hide() {
	puts("TODO");
	noReturnValue();
}

/**
 * Removes an object that was registered with addListener().
 **/
void ASMouse::removeListener() {
	puts("TODO");
	noReturnValue();
}

/**
 * Displays the mouse pointer in the SWF file.
 **/
void ASMouse::show() {
	puts("TODO");
	noReturnValue();
}
