/**
Action Script library. NetStream class implementation
Copyright (C) 2005

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**/
#include "as_net_stream.hh"

typedef void (ASNetStream::*funcPtr)();
static funcPtr callbacks[]= { 
	&ASNetStream::init,			// 0
	&ASNetStream::close,		// 1
	&ASNetStream::pause,		// 2
	&ASNetStream::play,			// 3
	&ASNetStream::seek,			// 4
	&ASNetStream::setBufferTime,// 5
	// Need to be at the end.
	&ASNetStream::addProperty,		
	&ASNetStream::registerClass,	
	&ASNetStream::AStoString,		
	&ASNetStream::unwatch,			
	&ASNetStream::valueOf,			
	&ASNetStream::watch
};

/**
 * The constructor
 **/
ASNetStream::ASNetStream(Script *s, Graphics *g) : ASObject(s,g,L"NetStream") {
}

/**
 * The destructor
 **/
ASNetStream::~ASNetStream() {
}

/**
 * Return a function descriptor
 */
Function *ASNetStream::getFunctionMember(wstring memberName) {
	Function *func = getBaseFunction(memberName);
	if (memberName == L"NetStream")		{func->setFunctionIndex(0); func->setNumParams(1); }
	if (memberName == L"close") 		{func->setFunctionIndex(1); func->setNumParams(0); }
	if (memberName == L"pause") 		{func->setFunctionIndex(2); func->setNumParams(1); }
	if (memberName == L"play") 			{func->setFunctionIndex(3); func->setNumParams(1); }
	if (memberName == L"seek") 			{func->setFunctionIndex(4); func->setNumParams(1); }
	if (memberName == L"setBufferTime")	{func->setFunctionIndex(5); func->setNumParams(1); }
	finishFunctionSetup(memberName,6,func);
	return func;
}

/**
 * Call class built in functions
 **/
void ASNetStream::callFunction(Function *func) {
	numPassedParams = func->getNumPassedParams();
	(this->*callbacks[func->getFunctionIndex()])();
}

/**
 *
 **/
void ASNetStream::init() {
	puts("TODO");
}

/**
 * Closes the stream but does not clear the video object.
 **/
void ASNetStream::close() {
	puts("TODO");
	noReturnValue();
}

/**
 * Pauses or resumes playback of a stream.
 **/
void ASNetStream::pause() {
	puts("TODO");
	noReturnValue();
}

/**
 * Begins playback of an external video (FLV) file.
 **/
void ASNetStream::play() {
	puts("TODO");
	noReturnValue();
}

/**
 * Seeks a specific position in the FLV file.
 **/
void ASNetStream::seek() {
	puts("TODO");
	noReturnValue();
}

/**
 * Specifies how long to buffer data before starting to display the stream.
 **/
void ASNetStream::setBufferTime() {
	puts("TODO");
	noReturnValue();
}

