/**
Action Script library. String class
Copyright (C) 2005 Christophe Choquet (cchoquet@users.sourceforge.net)   

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**/
#ifndef _AS_STRING_HH
#define _AS_STRING_HH
#include "as_object.hh"

class ASString : public ASObject{
public:
	ASString(Script *s, Graphics *g);
	ASString(Script *s, Graphics *g, wstring value);
	~ASString();
	Function *getFunctionMember(wstring memberName);
	void 	callFunction(Function *f);
	void 	init();
	ASInterface*getNewInstance(Script *s,Graphics *g) { return new ASString(s,g); }

	void	charAt();
	void	charCodeAt();
	void	concat();
	void	fromCharCode() ;
	void	indexOf();
	void	lastIndexOf();
	void	slice();
	void	split();
	void	substr();
	void	substring();
	void	toLowerCase();
	void	toUpperCase();
	void	AStoString();
	wstring	toString();
	
private:
	wstring	value;
};
#endif
