/**
Action Script library. XML class definition
Copyright (C) 2005 Christophe Choquet (cchoquet@users.sourceforge.net)  

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**/
#ifndef _AS_XML_HH
#define _AS_XML_HH
#include "as_object.hh"
#include <libxml/parser.h>
#include <libxml/tree.h>

class ASXml : public ASObject{
public:
	ASXml(Script *s, Graphics *g);
	~ASXml();
	Function *getFunctionMember(wstring memberName);
	void 	callFunction(Function *f);
	void 	init();
	ASInterface*getNewInstance(Script *s,Graphics *g) { return new ASXml(s,g); }
	void 	setMember(wstring memberName, ValueObject *v);
	ValueObject*getMember(wstring memberName);

	void	addRequestHeader();
	void	appendChild();
	void	cloneNode();
	void	createElement();
	void	createTextNode();
	void	getBytesLoaded();
	void	getBytesTotal();
	void	hasChildNodes();
	void	insertBefore();
	void	load();
	void	parseXML();
	void	removeNode();
	void	send();
	void	sendAndLoad();
	void	AStoString();
/*
	char	contentType;
	char	docTypeDecl;
	char	firstChild;
	char	ignoreWhite;
	char	lastChild;
	char	loaded;
	char	nextSibling;
	char	nodeName;
	char	nodeType;
	char	nodeValue;
	char	parentNode;
	char	previousSibling;
	char	status;
	char	xmlDecl;
	char	attributes;
	char	childNodes;
	char	onData;*/
	void	onLoad();
private:
	char		*source;		// in unicode
	int 		sourceLen;
	xmlDocPtr	doc;
	xmlNode 	*rootElement ;
	xmlNode 	*curNode;
	bool		isParsed;

	void		convertInputSource(wstring documentText);
};
#endif
