/**
Macromedia Flash Rendering engine.
Copyright (C) 2004  Christophe Choquet (cchoquet@users.sourceforge.net)

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**/
#ifndef _SWF_CONTROL_H_
#define _SWF_CONTROL_H_
#include "common.hh"
#include "swf.hh"
#include "swf_tags.hh"
#include "ogl_renderer.hh"
#include "script.hh"
#include <pthread.h>
#include "ASLib/as_sprite.hh"
#include "ASLib/as_button.hh"

class EventManager;
class Swf_decoder;

class SwfEngine {
public:
	SwfEngine(Swf_decoder *);
	~SwfEngine();
	void	next();
	void	display();
	void	goToMainTrackFrame(int frame);
	bool	mouseClickCallback(int x, int y,int mouseAction);
	void 	keyboardCallback(int key, char *code);
	void 	actionDispatch(UI8 **p);
	void	tagDispatch(BaseTag *tag);
	bool	isSpriteObject(ASInterface *);
	void	doDisplay();
	OglRenderer	*getOglRenderer() { return oglRenderer; }
	EventManager*getEventManager() { return eventManager; }
	Script	*getScript() { return script; }
	void	actionPreviousFrame();
	void	addAction(DoActiontag*t) { doActionList.push_back(t); }
	ASInterface*getGlobal() { return global; }
	HEADER	getHeader() { return header; }
	LocalFontManager *getFontManager() { return localFontManager; }
	void	setActionSkip(int p) { actionSkip = p; }
	void	setWaitFrame(int p) { waitFrame = p; }
private:
	list<BaseTag*> *tagList;
	list<BaseTag*>::iterator mainTag;
	list<DoActiontag*> doActionList;
	int 		actionSkip;
	Graphics 	*graphics;
	OglRenderer	*oglRenderer;
	Texture 	*texture;
	LocalFontManager *localFontManager;
	ObjectStore	*objectStore;
	Script 		*script;
	EventManager *eventManager;
	bool		continueDecode;
	bool		drawingInProcess;
	pthread_mutex_t  synchro;
	int		highestMaskedLayer;
	UI8*	jpegTableData;
	bool	executeMode, noActionScript;
	int		currentFrame, waitFrame;
	HEADER	header;
	ASObject *global;
	bool	actionListChanged;

	void	doShowFrame();
	void	doPlaceObject2(PlaceObject2Tag *tag);
	void	innerDisplay(ASSprite *sprite);
	void	innerDoDisplay(ASSprite *sprite);
	void	goToFrame(int frame,list<BaseTag*> *tagList);
	void	processExportAsset(ExportAssetsTag *t);
	void	doInitActiontag(DoInitActionTag *tag);

	void	renderButton(ASButton *amc, int currentDepth);
	void	onEnterMainFrame();
	void	movieEnterFrameEvent();
	void	spriteEnterFrameEvent(ASSprite *sprite);
	void	removeObject(RemoveObject2Tag *t);
};
#endif

